import { Keyboard, TouchableOpacity } from 'react-native';
import React, { Component } from 'react';
import { View, ScrollView, Text } from 'react-native'
import ImagePicker from 'react-native-image-crop-picker';
import ActionSheet from 'react-native-actionsheet'

export default class SelectImage extends Component {
    constructor(props) {
        super(props);
        Keyboard.dismiss();
        this.state = {
        }
    }
    show(_options) {
        return new Promise((resolve, reject) => {
            this.resolve = resolve;
            this.reject = reject;
            let options = _options || {};
            options.cropping = _options.cropping ? true : false

            this.setState({
                options
            }, ()=>{
                this.ActionSheet.show();
            });

        })
    }
    open(cropping, width, height, callback) {
        this.resolve = callback;
        let options = {
            cropping: cropping,
            width: width,
            height: height
        };
        this.setState({
            options
        }, ()=>{
            this.ActionSheet.show();
        });

    }
    takePicture() {
        ImagePicker.openCamera(this.state.options).then(image => {
            if (this.resolve)
                this.resolve(image);
        }).catch(e => {
            if (this.reject)
                this.reject(e);
        });
    }

    selectImage() {
        ImagePicker.openPicker(this.state.options).then(image => {
            if (this.resolve)
                this.resolve(image);
        }).catch(e => {
            if (this.reject)
                this.reject(e);
        });
    }
    onActionSheet(index) {
        try {
            switch (index) {
                case 0:
                    this.selectImage();
                    return;
                case 1:
                    this.takePicture();
                    return;
            }
        } catch (error) {

        }

    }

    render() {
        let options = (this.props.listOptions || []);
        if (!options || options.length == 0)
            options = ['Chọn từ ảnh', 'Chụp ảnh', 'Hủy'];
        return (<ActionSheet
            ref={o => this.ActionSheet = o}
            options={options}
            cancelButtonIndex={2}
            // destructiveButtonIndex={1}
            onPress={this.onActionSheet.bind(this)}
        />)
    }

}
